<?php
/**********************************************************************************
* Detectfree.php - PHP interface for DetectFree service
* which is a stripped service version of MovilaDetection server-side software.
* Currently one property is available, "is_mobile".
* @author Movila Ltd. <info@moviladetection.com>
* @version 0.1
* A function for getting parameters of the device
* @property is_mobile possible values "undef", "true", "false"
* @return new object $detectfree_check contains properties of the device
* Origional source dated April 08, 2010 by JMiller (a/k/a butchs) & Fabius
* (http://www.eastcoastrollingthunder.com) 
*********************************************************************************
* This program is distributed in the hope that it is and will be useful, but
* WITHOUT ANY WARRANTIES; without even any implied warranty of MERCHANTABILITY
* or FITNESS FOR A PARTICULAR PURPOSE.
**********************************************************************************/

if (!defined('SMF'))
	die('Hacking attempt...');

function iphone_getProperties($ip)
{
	global $txt, $modSettings, $detectfree_check, $iphone_runonce, $iphonename, $webmaster_email, $iphone_switchlink;

    $detectfree_check = new stdClass();

	$ip = trim($ip);
	$ip_temp = $ip;
	$cache_flag = false;

	// Check the session
	if (isset($_SESSION[$iphonename])) {
		$iphone_session_array = array();								// Declare values
		$iphone_session_array = explode("|", $_SESSION[$iphonename]);
		$detectfree_check = $iphone_session_array[0];					// iphone_lookup
		if (isset($_SESSION['id_theme']))	{							// Did the theme session expire?
			$iphone_runonce = $iphone_session_array[1];					// no reuse iphone_runonce
		} else {
			if($iphone_session_array[0] != "true")	{					// do nothing if not mobile
				$iphone_runonce = $iphone_session_array[1];
			} else {
				$iphone_runonce = $iphone_session_array[1] = "false";	// enable SWITCH theme
				iphone_loadSession($iphone_session_array);				// write changed session
		}	}
		unset($iphone_session_array);									// clean up
    return;
	}

	// Check the cookie  --  if I made it this fare the session is gone
	if (isset($_COOKIE[$iphonename])) {
		$iphone_cookie_array = array();									// Declare values
		$iphone_cookie_array = explode("|", $_COOKIE[$iphonename]);
		$detectfree_check = $iphone_cookie_array[0];					// iphone_lookup
		$iphone_runonce = $iphone_cookie_array[1] = "false";			// No session, enable SWITCH theme
																		// switch link - old cookie chk
		$iphone_switchlink = ($iphone_cookie_array[2] == '' ? "true": $iphone_cookie_array[2]);
		iphone_loadSession($iphone_cookie_array);						// new session
		unset($iphone_cookie_array);									// clean up
		return;	}

		if (!$ip || $ip == '')											// If ip is empty
			$ip = '0-0-0-0';

		$ip2 = '';
		$ip2 = str_replace('.', '-', $ip);

		if (!$modSettings['iphone_cache_ignore']) {
			if ((empty($modSettings['cache_enable'])) || ($modSettings['cache_enable'] == 0)) {
				loadLanguage('Errors');
				log_error($txt['iphcache'], 'user'); } }

		$cache_flag = iphone_checkCache($ip2);

	// Check cache before going to Detectfree  ---  so far no session and no cookie
	if ((!empty($modSettings['cache_enable'])) && ($modSettings['cache_enable'] >= 1) && ($cache_flag)) {
		$cache_content = "";											// Declare values
		$iphone_cache_array = array();
		if ($ip2 == '') {												// Check IP address
			$ip2 = '0-0-0-0'; }
		$cache_content = cache_get_data('4iphone-' . $ip2, 0);
		$iphone_cache_array = explode("|", $cache_content);
		$detectfree_check = $iphone_cache_array[0];						// iphone_lookup
		$iphone_runonce = $iphone_cache_array[1] = "false";				// No session & cookie, enable SWITCH theme
																		// switch link - old cache chk
		$iphone_switchlink = ($iphone_cache_array[2] == '' ? "true": $iphone_cache_array[2]);
		iphone_loadSession($iphone_cache_array);						// new session
		unset($iphone_cache_array);										// clean up
		unset($ip2, $cache_content);
   		return; }

	// No data in SMF cache about this IP or session and no cookie. Time to check the Detectfree db
        $headers = "";
        if (function_exists("getAllHeaders")) {
                foreach (getAllHeaders() as $key => $value) {
                        $key_lower = strtolower($key);
                        if ($key_lower == "connection") continue;
                        if ($key_lower == "content-length") continue;
                        if ($key_lower == "content-type") continue;
                        if ($key_lower == "host") continue;
                        if ($key_lower == "keep-alive") continue;
                        $headers .= "$key: $value\r\n";
                }
        } else {
                foreach ($_SERVER as $key => $value) {
                        if (substr($key, 0, 5) == "HTTP_") {
                                $key = str_replace("_", " ", substr($key, 5));
                                $key = str_replace(" ", "-", ucwords(strtolower($key)));
                                $key_lower = strtolower($key);
                                if ($key_lower == "connection") continue;
                                if ($key_lower == "content-length") continue;
                                if ($key_lower == "content-type") continue;
                                if ($key_lower == "host") continue;
                                if ($key_lower == "keep-alive") continue;
                                $headers .= "$key: $value\r\n";
                        }
                }
        }
        
        $url = "http://detectfree.moviladetection.com/";
		$contents  = iphone_fetch_web_data($url, $headers);

		$is_mobile = "undef";

		if (!$contents) {
 			loadLanguage('Errors');
			log_error($txt['iphDNS'], 'user');							// could not connect
        } else {
                $lines = explode("\r?\n", $contents);
                
                foreach ($lines as $line) {
                        $pos = strpos($line, ":");
                        if ($pos && strlen($line) > $pos + 1) {
                                $key = substr($line, 0, $pos);
                                $value = substr($line, $pos + 1);
                                if ($key == "is_mobile")
                                        $is_mobile = $value;
                        }
                }
        }

	if ($is_mobile != "true")
		$detectfree_check = "false";									// iphone_lookup
	else
		$detectfree_check = "true";										// iphone_lookup

	$iphone_runonce = "false";											// iphone_runonce

	// Try to put the data in the cache for the first time, if it's enabled, not there & set properly
	if ((!empty($modSettings['cache_enable'])) && ($modSettings['cache_enable'] >= 1) && (!$cache_flag)) {
		$iphone_cach_array = array();									// Declare values
		$iphone_cach_array[0] = $detectfree_check;						// iphone_lookup
		$iphone_cach_array[1] = $iphone_runonce;						// iphone_runonce
		$iphone_cach_array[2] = $iphone_runonce;						// switch_link
		iphone_loadCache($ip, $iphone_cach_array);						// do the deed
		unset($iphone_cach_array); }									// clean up

	// Try to put the data in a cookie if no cookie exists
	if (!isset($_COOKIE[$iphonename])) {
		$iphone_cookie_array = array();									// Declare values
		$iphone_cookie_array[0] = $detectfree_check;					// iphone_lookup
		$iphone_cookie_array[1] = $iphone_runonce;						// iphone_runonce
		$iphone_cookie_array[2] = $iphone_runonce;						// switch_link
		iphone_setPassCookie($iphone_cookie_array);						// Do the deed
		unset($iphone_cookie_array); }									// clean up

	// Try to put the data in the session if none exists
	if (!isset($_SESSION[$iphonename])) {
		$iphone_session_array = array();								// Declare values
		$iphone_session_array[0] = $detectfree_check;					// iphone_lookup
		$iphone_session_array[1] = $iphone_runonce;						// iphone_runonce
		iphone_loadSession($iphone_session_array);						// Do the deed
		unset($iphone_session_array); }									// clean up

	unset($ip2, $is_mobile, $cache_flag);

return; }

function iphone_themeSwitch($ip) {
	global $txt, $scripturl, $modSettings, $detectfree_check, $iphone_runonce, $iphone_switchlink, $iphonename, $failsafe_link;

		$failsafe_link = "true";
		$agent = $pattern = $id_theme = '';

		$agent = strtolower($agent ? $agent : $_SERVER['HTTP_USER_AGENT']);

		if (!empty($modSettings['phrase1']) && !empty($modSettings['id_theme1'])) {
			$pattern = '#(' . strtolower($modSettings['phrase1']) .')[/ ]#';
		if (preg_match($pattern, $agent)) {
			$failsafe_link = "false";
			if(($iphone_switchlink == $modSettings['id_theme1']) || ($iphone_switchlink == "false")) {
				$_SESSION[$iphonename] = "true|true";
				$id_theme = $iphone_switchlink = $modSettings['id_theme1'];
				iphone_setRunOnce($ip);
				$_SESSION['id_theme'] = $id_theme;
				echo '
				<script type="text/javascript">
				window.location.url="', $scripturl, '?theme=', $id_theme, '";
				</script>';
			} else {
				iphone_reset($ip); }	}						// do over - no longer a match
		}
		if (!empty($modSettings['phrase2']) && !empty($modSettings['id_theme2'])) {
			$pattern = '#(' . strtolower($modSettings['phrase2']) .')[/ ]#';
		if (preg_match($pattern, $agent)) {
			$failsafe_link = "false";
			if(($iphone_switchlink == $modSettings['id_theme2']) || ($iphone_switchlink == "false")) {
				$_SESSION[$iphonename] = "true|true";
				$id_theme = $iphone_switchlink = $modSettings['id_theme2'];
				iphone_setRunOnce($ip);
				$_SESSION['id_theme'] = $id_theme;
				echo '
				<script type="text/javascript">
				window.location.url="', $scripturl, '?theme=', $id_theme, '";
				</script>';
			} else {
				iphone_reset($ip); }	}						// do over - no longer a match
		}
		if (!empty($modSettings['phrase3']) && !empty($modSettings['id_theme3'])) {
			$pattern = '#(' . strtolower($modSettings['phrase3']) .')[/ ]#';
		if (preg_match($pattern, $agent)) {
			$failsafe_link = "false";
			if(($iphone_switchlink == $modSettings['id_theme3']) || ($iphone_switchlink == "false")) {
				$_SESSION[$iphonename] = "true|true";
				$id_theme =  $iphone_switchlink = $modSettings['id_theme3'];
				iphone_setRunOnce($ip);
				$_SESSION['id_theme'] == $id_theme;
				echo '
				<script type="text/javascript">
				window.location.url="', $scripturl, '?theme=', $id_theme, '";
				</script>';
			} else {
				iphone_reset($ip); }	}						// do over - no longer a match
		}
	// Enter SMF built in as a default wap, wap2 or imode here in future you may want to do as an optional check mark
		if ($failsafe_link == "true") {
			if($iphone_switchlink != "false") {
				iphone_reset($ip);							// do over - every time a session expires
			} else {
				$_SESSION[$iphonename] = "true|true";
				$iphone_switchlink = $modSettings['failsafe_link'];  // this does nothing
				iphone_setRunOnce($ip);
				echo '
				<script type="text/javascript">
				window.location.url="', $scripturl, '?', $modSettings['failsafe_link'], '";
				</script>'; }	}
	unset($failsafe_link, $agent, $pattern, $id_theme);					// clean up

return; }

function iphone_reset($ip) {

	global $txt, $iphonename;

	$ip2 = '';
	$ip2 = str_replace('.', '-', $ip);									// Check IP address
	if ($ip2 == '')
		$ip2 = '0-0-0-0';

	cache_put_data('4iphone-' . $ip2, Null, 120);						// erase the cache
	unset($ip2);														// clean up
	unset($_COOKIE[$iphonename]);										// erase the cookie
	unset($_SESSION[$iphonename]);										// erase the session
	return;
}

function iphone_setRunOnce($ip)
{
	global $txt, $modSettings, $detectfree_check, $iphone_runonce, $iphone_switchlink, $iphonename, $failsafe_link;

	if($failsafe_link == '')
		$failsafe_link = "true";

 	// Apparently sometimes $_SERVER['REMOTE_ADDR'] add white space
	$ip = trim($ip);
	$cache_flag = false;

	$ip2 = '';
	$ip2 = str_replace('.', '-', $ip);

	$cache_flag = iphone_checkCache($ip2);								// does cache exist

	// If $ip is empty let's try to find it with more methods
	if (!$ip || $ip == '')
		$ip = '0-0-0-0';

	$iphone_runonce = "true";											// iphone_runonce

	// Try to put the data in the cache, if it's enabled and set properly
	if ((!empty($modSettings['cache_enable'])) && ($modSettings['cache_enable'] >= 1) && (!$cache_flag)) {
		$iphone_cach_array = array();									// Declare values
		$iphone_cach_array[0] = $detectfree_check;						// iphone_lookup
		$iphone_cach_array[1] = $iphone_runonce;						// iphone_runonce
		$iphone_cach_array[2] = $iphone_switchlink;						// switch link
		iphone_loadCache($ip, $iphone_cach_array);						// Do the deed
		unset($iphone_cach_array); }									// clean up

	// Try to put the data in a cookie if no cookie exists
	if (!isset($_COOKIE[$iphonename])) {
		$iphone_cookie_array = array();									// Declare values
		$iphone_cookie_array[0] = $detectfree_check;					// iphone_lookup
		$iphone_cookie_array[1] = $iphone_runonce;						// iphone_runonce
		$iphone_cookie_array[2] = $iphone_switchlink;							// switch link
		iphone_setPassCookie($iphone_cookie_array); 					// Do the deed
		unset($iphone_cookie_array); }									// clean up

return; }

function iphone_loadSession($iphone_session_array) {
	global $iphonename;

	if (empty($iphone_session_array))									// Can't just look for no array
		return;
	if (!is_array($iphone_session_array))								// Make sure it's a array
		return;
	$session_content = "";
	foreach($iphone_session_array as $key => $value) {
		$session_content .= $value . "|"; }
 	$session_content = substr($session_content, 0, -1);					// trim the last | from the end
	$_SESSION[$iphonename] = $session_content;							// Set the session
	unset($session_content);											// clean up
	return; }

function iphone_setPassCookie($iphone_cookie_array) {
	global $iphonename;

	if (empty($iphone_cookie_array))									// Can't just look for no array
		return;
	if (!is_array($iphone_cookie_array))								// Make sure it's a array
		return;
	$iphone_expire = 0;													// Declare values
	$cookie_content = "";
	$iphone_expire = time()+60*60*1*24;									// Set cookie expiration time 24 hrurs
	foreach($iphone_cookie_array as $key => $value) {
		$cookie_content .= $value . "|"; }
 	$cookie_content = substr($cookie_content, 0, -1);					// trim the last | from the end
	setcookie($iphonename, $cookie_content, $iphone_expire);			// Set the cookie
	unset($iphone_expire, $cookie_content);								// clean up
	return; }

function iphone_loadCache($ip, $iphone_cach_array) {

	global $txt;

	if (empty($iphone_cach_array))										// Can't just look for no array
		return;
	if (!is_array($iphone_cach_array))									// Make sure it's a array
		return;
	$iphone_expire = 0;													// Declare values
	$cache_content = "";
	$ip2 = '';
	foreach($iphone_cach_array as $key => $value) {
		$cache_content .= $value . "|"; }
 	$cache_content = substr($cache_content, 0, -1);						// trim the last | from the end
	$ip2 = str_replace('.', '-', $ip);									// Check IP address
	if ($ip2 == '') {
		$ip2 = '0-0-0-0';
		$iphone_expire = 60*2.5;											// set cache to 2.5 minutes for fake IP
	} else {
		$iphone_expire = 60*60*1*24; }									// set cache to 24 hours for a good IP
	cache_put_data('4iphone-' . $ip2, $cache_content, $iphone_expire);	// Set the cache
	unset($ip2, $iphone_expire, $cache_content);						// clean up
	return;
}

function iphone_checkCache($ip2) {
	global $txt, $modSettings;

	$cache_content = "";												// Declare values
	$iphone_cache_array = array();
	if ($ip2 == '') {													// Check IP address
		$ip2 = '0-0-0-0'; }
	$cache_content = cache_get_data('4iphone-' . $ip2, 0);				// Check cache
	if (empty($cache_content)) {
		unset($cache_content);											// clean up
       	return false; }
	unset($iphone_cache_array);											// clean up
	unset($cache_content);
return true;
}

// Get the contents of a URL, irrespective of allow_url_fopen.
function iphone_fetch_web_data($url, $post_data = '', $keep_alive = false, $redirection_level = 0)
{
	global $webmaster_email;
	static $keep_alive_dom = null, $keep_alive_fp = null;

	preg_match('~^(http|ftp)(s)?://([^/:]+)(:(\d))?(.+)$~', $url, $match);

	// An FTP url. We should try connecting and RETRieving it...
	if (empty($match[1]))
		return false;
	elseif ($match[1] == 'ftp')
	{
		// Include the file containing the ftp_connection class.
		loadClassFile('Class-Package.php');

		// Establish a connection and attempt to enable passive mode.
		$ftp = new ftp_connection(($match[2] ? 'ssl://' : '') . $match[3], empty($match[5]) ? 21 : $match[5], 'anonymous', $webmaster_email);
		if ($ftp->error !== false || !$ftp->passive())
			return false;

		// I want that one *points*!
		fwrite($ftp->connection, 'RETR ' . $match[6] . "\r\n");

		// Since passive mode worked (or we would have returned already!) open the connection.
		$fp = @fsockopen($ftp->pasv['ip'], $ftp->pasv['port'], $err, $err, 5);
		if (!$fp)
			return false;

		// The server should now say something in acknowledgement.
		$ftp->check_response(150);

		$data = '';
		while (!feof($fp))
			$data .= fread($fp, 4096);
		fclose($fp);

		// All done, right?  Good.
		$ftp->check_response(226);
		$ftp->close();
	}
	// This is more likely; a standard HTTP URL.
	elseif (isset($match[1]) && $match[1] == 'http')
	{
		if ($keep_alive && $match[3] == $keep_alive_dom)
			$fp = $keep_alive_fp;
		if (empty($fp))
		{
			// Open the socket on the port we want...
			$fp = @fsockopen(($match[2] ? 'ssl://' : '') . $match[3], empty($match[5]) ? ($match[2] ? 443 : 80) : $match[5], $err, $err, 5);
			if (!$fp)
				return false;
		}

		if ($keep_alive)
		{
			$keep_alive_dom = $match[3];
			$keep_alive_fp = $fp;
		}

		// I want this, from there, and I'm not going to be bothering you for more (probably.)
		if (empty($post_data))
		{
			fwrite($fp, 'GET ' . $match[6] . ' HTTP/1.0' . "\r\n");
			fwrite($fp, 'Host: ' . $match[3] . (empty($match[5]) ? ($match[2] ? ':443' : '') : ':' . $match[5]) . "\r\n");
			fwrite($fp, 'User-Agent: PHP/SMF' . "\r\n");
			if ($keep_alive)
				fwrite($fp, 'Connection: Keep-Alive' . "\r\n\r\n");
			else
				fwrite($fp, 'Connection: close' . "\r\n\r\n");
		}
		else
		{
			fwrite($fp, 'POST ' . $match[6] . ' HTTP/1.0' . "\r\n");
			fwrite($fp, 'Host: ' . $match[3] . (empty($match[5]) ? ($match[2] ? ':443' : '') : ':' . $match[5]) . "\r\n");
			fwrite($fp, 'User-Agent: PHP/SMF' . "\r\n");
			if ($keep_alive)
				fwrite($fp, 'Connection: Keep-Alive' . "\r\n");
			else
				fwrite($fp, 'Connection: close' . "\r\n");
			fwrite($fp, 'Content-Type: application/x-www-form-urlencoded' . "\r\n");
			fwrite($fp, 'Content-Length: ' . strlen($post_data) . "\r\n\r\n");
			fwrite($fp, $post_data);
		}

		$response = fgets($fp, 768);

		// Redirect in case this location is permanently or temporarily moved.
		if ($redirection_level < 3 && preg_match('~^HTTP/\S+\s+30[127]~i', $response) === 1)
		{
			$header = '';
			$location = '';
			while (!feof($fp) && trim($header = fgets($fp, 4096)) != '')
				if (strpos($header, 'Location:') !== false)
					$location = trim(substr($header, strpos($header, ':') + 1));

			if (empty($location))
				return false;
			else
			{
				if (!$keep_alive)
					fclose($fp);
				return iphone_fetch_web_data($location, $post_data, $keep_alive, $redirection_level + 1);
			}
		}

		// Make sure we get a 200 OK.
		elseif (preg_match('~^HTTP/\S+\s+20[01]~i', $response) === 0)
			return false;

		// Skip the headers...
		while (!feof($fp) && trim($header = fgets($fp, 4096)) != '')
		{
			if (preg_match('~content-length:\s*(\d+)~i', $header, $match) != 0)
				$content_length = $match[1];
			elseif (preg_match('~connection:\s*close~i', $header) != 0)
			{
				$keep_alive_dom = null;
				$keep_alive = false;
			}

			continue;
		}

		$data = '';
		if (isset($content_length))
		{
			while (!feof($fp) && strlen($data) < $content_length)
				$data .= fread($fp, $content_length - strlen($data));
		}
		else
		{
			while (!feof($fp))
				$data .= fread($fp, 4096);
		}

		if (!$keep_alive)
			fclose($fp);
	}
	else
	{
		// Umm, this shouldn't happen?  --  edited this section only for smf4iphone
		$data = '';
	}

	return $data;
}
?>