<?php
/**********************************************************************************
* install_db.php - Search & install database items and set chmod
* Programmed on Mar 05, 2010 by JMiller  (a/k/a butchs) & Fabius
* (http://www.eastcoastrollingthunder.com) 
*********************************************************************************
* This program is distributed in the hope that it is and will be useful, but
* WITHOUT ANY WARRANTIES; without even any implied warranty of MERCHANTABILITY
* or FITNESS FOR A PARTICULAR PURPOSE.
**********************************************************************************/

global $smcFunc, $language, $user_info, $db_prefix, $ssi_theme, $settings;

// If SSI.php is in the same place as this file, and SMF isn't defined, this is being run standalone.
if (file_exists(dirname(__FILE__) . '/SSI.php') && !defined('SMF'))
	require_once(dirname(__FILE__) . '/SSI.php');
// Hmm... no SSI.php and no SMF?
elseif (!defined('SMF'))
	die('<b>Error:</b> Cannot install - please verify you put this in the same place as SMF\'s index.php.');

if(isset($smcFunc))
{
	$id_theme1 = '5';
	$id_theme2 = '';
	$id_theme3 = '';
	$id_default_theme = '1';
	$iphone_cache_ignore = '0';

	// Try to find the current theme settings ID assuming it is default
	if(isset($settings['theme_id']))
		$id_default_theme = $settings['theme_id'];

	// Try to find the current cache settings
	if(isset($settings['cache_ignore']))
		$iphone_cache_ignore = $settings['cache_ignore'];

	// Try to find SMF4iPhone ID assuming mod is installed
	$request = $smcFunc['db_query']('', '
		SELECT id_theme, variable, value
		FROM {db_prefix}themes
		WHERE variable = {string:name}
			AND value = {string:value}',
		array(
			'value' => 'SMF4iPhone',
			'name' => 'name',
		)
	);
	if ($smcFunc['db_num_rows']($request) !== 0) {
		list($id_theme) = $smcFunc['db_fetch_row']($request);
		$id_theme1 = $id_theme; }

	$smcFunc['db_free_result']($request);

	// Try to find Curve-Mobile ID assuming mod is installed
	$request = $smcFunc['db_query']('', '
		SELECT id_theme, variable, value
		FROM {db_prefix}themes
		WHERE variable = {string:name}
			AND value = {string:value}',
		array(
			'value' => 'curve-mobile',
			'name' => 'name',
		)
	);
	if ($smcFunc['db_num_rows']($request) !== 0) {
		list($id_theme) = $smcFunc['db_fetch_row']($request);
		$id_theme2 = $id_theme; }

	$smcFunc['db_free_result']($request);

	// Try to find mobile theme ID assuming mod is installed
	$request = $smcFunc['db_query']('', '
		SELECT id_theme, variable, value
		FROM {db_prefix}themes
		WHERE variable = {string:name}
			AND value = {string:value}',
		array(
			'value' => 'mobile',
			'name' => 'name',
		)
	);
	if ($smcFunc['db_num_rows']($request) !== 0) {
		list($id_theme) = $smcFunc['db_fetch_row']($request);
		$id_theme3 = $id_theme; }

	$smcFunc['db_free_result']($request);

	$phrase1 = 'iphone|ipod|android|mobile|Safari Mobile';
	$phrase2 = 'iemobile|Opera Mobi|symbian|series60|series70|series80|series90|series 60|series 70|series 80|series 90|blackberry|blackberry05|palm|webos';
	$phrase3 = 'nokia|motorola|samsung|fennec|minimo|sonyericsson|htc';
	$failsafe_link= 'wap2';

	$smcFunc['db_insert']('ignore',
		$db_prefix . 'settings',
		array('variable' => 'string', 'value' => 'string',
		),
		array(
			array('id_theme1', $id_theme1),
			array('id_theme2', $id_theme2),
			array('id_theme3', $id_theme3),
			array('failsafe_link', $failsafe_link),
			array('phrase1', $phrase1),
			array('phrase2', $phrase2),
			array('phrase3', $phrase3),
			array('id_default_theme', $id_default_theme),
			array('iphone_cache_ignore', $iphone_cache_ignore)
		),
		array('variable')
	);
} else {

	db_query("
		INSERT IGNORE INTO {$db_prefix}settings 
		VALUES ('id_theme1', '5')
	", __FILE__, __LINE__);

	db_query("
		INSERT IGNORE INTO {$db_prefix}settings 
		VALUES ('id_theme2', '')
	", __FILE__, __LINE__);


	db_query("
		INSERT IGNORE INTO {$db_prefix}settings 
		VALUES ('id_theme3', '')
	", __FILE__, __LINE__);

	db_query("
		INSERT IGNORE INTO {$db_prefix}settings 
		VALUES ('failsafe_link', 'wap2')
	", __FILE__, __LINE__);

	db_query("
		INSERT IGNORE INTO {$db_prefix}settings 
		VALUES ('phrase1', '')
	", __FILE__, __LINE__);

	db_query("
		INSERT IGNORE INTO {$db_prefix}settings 
		VALUES ('phrase2', '')
	", __FILE__, __LINE__);

	db_query("
		INSERT IGNORE INTO {$db_prefix}settings 
		VALUES ('phrase3', '')
	", __FILE__, __LINE__);

	db_query("
		INSERT IGNORE INTO {$db_prefix}settings 
		VALUES ('id_default_theme', '1')
	", __FILE__, __LINE__);

	db_query("
		INSERT IGNORE INTO {$db_prefix}settings 
		VALUES ('iphone_cache_ignore', '0')
	", __FILE__, __LINE__);
}

?>